Page MenuHomePhabricator

Replicate custom Zero exit interstitial behavior in Android App
Closed, ResolvedPublic5 Story Points

Description

Update the Wikipedia Zero exit interstitial to duplicate the functionality that was recently added to the web UI.

This includes:
Per-partner overrides of default text for Title, warning, optional button label and link.

Event Timeline

DFoy created this task.Nov 19 2015, 10:02 PM
DFoy raised the priority of this task from to Needs Triage.
DFoy updated the task description. (Show Details)
DFoy added subscribers: DFoy, dr0ptp4kt.
Restricted Application added subscribers: StudiesWorld, Aklapper. · View Herald TranscriptNov 19 2015, 10:02 PM
dr0ptp4kt set Security to None.
dr0ptp4kt moved this task from Backlog to Feature on the Reading-Admin board.Nov 23 2015, 9:43 PM
dr0ptp4kt moved this task from Feature to Doing on the Reading-Admin board.
dr0ptp4kt moved this task from Doing to Next Quarter Candidates on the Reading-Admin board.
Dbrant added a subscriber: Dbrant.EditedNov 30 2015, 4:34 PM

@dr0ptp4kt @DFoy Can you link to the task(s) that represent this work as it was done on the Web side? (Or a link to the specification for how this data is received and formatted, as well as any design mocks)

Received. Will update.

Note to future self filling in details: point to some relevant files to aid in the coding task.

Mholloway claimed this task.Jan 6 2016, 8:56 PM

The design mocks have been shared. Subtask T115398 regarding the EL schema added for consult from data analyst. @Dbrant, @Mholloway: do you want a separate task for the actual EL wireup?

@dr0ptp4kt Sure, I can write one up and add as a blocker to T115398, free to edit as necessary.

Change 264859 had a related patch set uploaded (by Mholloway):
Add exit titles and warnings to API message response

https://gerrit.wikimedia.org/r/264859

@dr0ptp4kt We deferred on estimating this at the most recent Android estimation meeting because the title seems broad but the description is narrow. Does this task encompass just plugging in the strings soon to be available pending the API-side changes? Or is there broader work around testing the mobile web and emulating its behavior (for example, when switching wifi networks)?

We were on the fence about whether to pull this task into the current sprint but it's looking to me like we might have the bandwidth, at least under the narrow interpretation of the task.

@Mholloway, thanks for checking.

Yes, the client side code should apply a different dialog depending on the current config.

If the user has two SIM cards, both for zero-rated operators, but one operator has the non-customized config, yet the other has the customized config, should the user be using the app and switch between the two operators with SIM switching, the app should show the appropriate dialog for that user when she taps on a third party link (assuming the option in More... / settings is checked for warning about leaving, as usual).

Change 264859 merged by jenkins-bot:
Add exit titles and warnings to API message response

https://gerrit.wikimedia.org/r/264859

Change 269548 had a related patch set uploaded (by Mholloway):
Add support for custom carrier exit interstitial messages

https://gerrit.wikimedia.org/r/269548

Change 269548 merged by jenkins-bot:
Add support for custom carrier exit interstitial messages

https://gerrit.wikimedia.org/r/269548

Let's not call this a win yet. I'm currently still working on some of the implementation of the new stuff, though the groundwork was laid in the patch just merged.

Sorry this has been so disjointed, but there have been kind of a lot of "gotchas."

MBinder_WMF edited a custom field.Feb 12 2016, 7:18 PM
Mholloway renamed this task from Replicate custom exit interstitial behavior in Android App to Replicate custom Zero exit interstitial behavior in Android App.Feb 15 2016, 8:31 PM
Mholloway added a comment.EditedFeb 15 2016, 8:56 PM

On the state transition piece, I've verified that state transitions are made as expected across the following changes:

  1. Non-zero-rated connection to zero-rated connection;
  2. Zero-rated connection to non-zero-rated connection;
  3. One zero-rated connection to another that's zero-rated by a different provider.

A couple of follow-up changes related to updating the Zero state when the app language changes are in progress:
T126815: [Bug] Going from a zero-rated site ("Wikipedia language") to a non-zero-rated site does not trigger Wikipedia Zero state change event
T126997: [Bug] Switching the Wikipedia language while Zero is enabled does not update the nav menu zero message

Change 271079 had a related patch set uploaded (by Mholloway):
Add bannerUrl to zero config API response

https://gerrit.wikimedia.org/r/271079

Change 271079 merged by jenkins-bot:
Add bannerUrl to zero config API response

https://gerrit.wikimedia.org/r/271079

@Mholloway There is not enough information in this ticket for a third party to be able to test. Please add preconditions and steps to verify if you want this ticket tested by QA.

Dbrant closed this task as Resolved.Feb 29 2016, 3:25 PM